/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_controlplane/controlplane/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeKubeadmControlPlaneTemplates implements KubeadmControlPlaneTemplateInterface
type FakeKubeadmControlPlaneTemplates struct {
	Fake *FakeControlplaneV1beta1
	ns   string
}

var kubeadmcontrolplanetemplatesResource = schema.GroupVersionResource{Group: "controlplane.cluster.x-k8s.io", Version: "v1beta1", Resource: "kubeadmcontrolplanetemplates"}

var kubeadmcontrolplanetemplatesKind = schema.GroupVersionKind{Group: "controlplane.cluster.x-k8s.io", Version: "v1beta1", Kind: "KubeadmControlPlaneTemplate"}

// Get takes name of the kubeadmControlPlaneTemplate, and returns the corresponding kubeadmControlPlaneTemplate object, and an error if there is any.
func (c *FakeKubeadmControlPlaneTemplates) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.KubeadmControlPlaneTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(kubeadmcontrolplanetemplatesResource, c.ns, name), &v1beta1.KubeadmControlPlaneTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeadmControlPlaneTemplate), err
}

// List takes label and field selectors, and returns the list of KubeadmControlPlaneTemplates that match those selectors.
func (c *FakeKubeadmControlPlaneTemplates) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.KubeadmControlPlaneTemplateList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(kubeadmcontrolplanetemplatesResource, kubeadmcontrolplanetemplatesKind, c.ns, opts), &v1beta1.KubeadmControlPlaneTemplateList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.KubeadmControlPlaneTemplateList{ListMeta: obj.(*v1beta1.KubeadmControlPlaneTemplateList).ListMeta}
	for _, item := range obj.(*v1beta1.KubeadmControlPlaneTemplateList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested kubeadmControlPlaneTemplates.
func (c *FakeKubeadmControlPlaneTemplates) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(kubeadmcontrolplanetemplatesResource, c.ns, opts))

}

// Create takes the representation of a kubeadmControlPlaneTemplate and creates it.  Returns the server's representation of the kubeadmControlPlaneTemplate, and an error, if there is any.
func (c *FakeKubeadmControlPlaneTemplates) Create(ctx context.Context, kubeadmControlPlaneTemplate *v1beta1.KubeadmControlPlaneTemplate, opts v1.CreateOptions) (result *v1beta1.KubeadmControlPlaneTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(kubeadmcontrolplanetemplatesResource, c.ns, kubeadmControlPlaneTemplate), &v1beta1.KubeadmControlPlaneTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeadmControlPlaneTemplate), err
}

// Update takes the representation of a kubeadmControlPlaneTemplate and updates it. Returns the server's representation of the kubeadmControlPlaneTemplate, and an error, if there is any.
func (c *FakeKubeadmControlPlaneTemplates) Update(ctx context.Context, kubeadmControlPlaneTemplate *v1beta1.KubeadmControlPlaneTemplate, opts v1.UpdateOptions) (result *v1beta1.KubeadmControlPlaneTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(kubeadmcontrolplanetemplatesResource, c.ns, kubeadmControlPlaneTemplate), &v1beta1.KubeadmControlPlaneTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeadmControlPlaneTemplate), err
}

// Delete takes name of the kubeadmControlPlaneTemplate and deletes it. Returns an error if one occurs.
func (c *FakeKubeadmControlPlaneTemplates) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(kubeadmcontrolplanetemplatesResource, c.ns, name, opts), &v1beta1.KubeadmControlPlaneTemplate{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeKubeadmControlPlaneTemplates) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(kubeadmcontrolplanetemplatesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.KubeadmControlPlaneTemplateList{})
	return err
}

// Patch applies the patch and returns the patched kubeadmControlPlaneTemplate.
func (c *FakeKubeadmControlPlaneTemplates) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.KubeadmControlPlaneTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(kubeadmcontrolplanetemplatesResource, c.ns, name, pt, data, subresources...), &v1beta1.KubeadmControlPlaneTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeadmControlPlaneTemplate), err
}
